unit geo_calc_h;

interface
type float = Extended;
{$IFDEF UNIX}
const
 LibName = 'geo_calc.so';
{$ENDIF}

{$IFDEF WINDOWS}
const
 LibName = 'geo_calc.dll';
{$ELSE}
 {$IFNDEF UNIX}
const 
  LibName = 'geo_calc.dll';
 {$ENDIF}
{$ENDIF}

// ellipsoid parameters
const
    Airy1930 = 0;
    AustralianNational = 1;
    Bessel1941Europe = 2;
    Bessel1941Namibia = 3;
    Clarce1866 = 4;
    Clarce1880 = 5;
    Everest1 = 6;
    Everest2 = 7;
    Everest3 = 8;
    Everest4 = 9;
    Everest5 = 10;
    Everest6 = 11;
    GRS80    = 12;
    Helmert1906 = 13;
    Houg1960    = 14;
    Indonesian1974 = 15;
    International1924 = 16;
    Krassovsky1940 = 17;
    ModAiry = 18;
    ModFischer1960 = 19;
    SouthAmerican1969 = 20;
    WGS72 = 21;
    WGS84 = 22;
    PZ90  = 23;

//    90
function ellipse_PZ90: float; cdecl;
//   90
function alpha_PZ90: float; cdecl;
//   90
function e2_PZ90: float; cdecl;
//      90
function N_PZ90(latitude: float): float; cdecl;
//    WGS84
function ellipse_WGS84: float; cdecl;
//   WGS84
function alpha_WGS84: float; cdecl;
//   WGS84
function e2_WGS84: float; cdecl;
//      WGS84
function N_WGS84(latitude: float): float; cdecl;
//    42
function ellipse_SK42: float; cdecl;
//   42
function alpha_SK42: float; cdecl;
//   42
function e2_SK42: float; cdecl;
//      42
function N_SK42(latitude: float): float; cdecl;
//    95
function ellipse_SK95: float; cdecl;
function alpha_SK95: float; cdecl;
function e2_SK95: float; cdecl;
function N_SK95(latitude: float): float; cdecl;
//      42
function geo_distance_sk42(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl;
//      90
function geo_distance_PZ90(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl;
//      WGS84
function geo_distance_WGS84(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl;
function geo_distance_SK95(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl; 
function calc_distance_gaversinus(latitude1, longitude1, latitude2, longitude2, A : float): float; cdecl;
function calc_distance_gaversinus_large(latitude1, longitude1, latitude2, longitude2, A : float): float; cdecl;
function calc_initial_bearing(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_SK42(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_large_SK42(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_PZ90(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_large_PZ90(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_WGS84(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_large_WGS84(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_SK95(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;
function calc_distance_gaversinus_large_SK95(latitude1, longitude1, latitude2, longitude2: float): float; cdecl;


//      -
function gauss_kruger_zone(L :float): Integer; cdecl;
//       , 
function gauss_kruger_distance0(L: float): float; cdecl;
//  X   - (      42)
function gauss_kruger_x(latitude, longitude: float): float; cdecl;
//  Y   - (      42)
function gauss_kruger_y(latitude, longitude: float): float; cdecl;
//    -   42
function gauss_kruger_latitude(x, y: float): float; cdecl;
//    -   42
function gauss_kruger_longitude(x, y: float): float; cdecl;
//        
procedure transform_coo(ellipseFrom, ellipseTo: float; e2From, e2To: float;
  alphaFrom, alphaTo: float; latFrom, LongFrom, HeightFrom: float; dX, dY, dZ, wX, wY, wZ, dM: float;
  var latTo, longTo, HeightTo: float); cdecl;
//    42  90
function SK42_to_PZ90_latitude(latSK42, longSK42, HeightSK42: float): float; cdecl;
//    42  90
function SK42_to_PZ90_longitude(latSK42, longSK42, HeightSK42: float): float; cdecl;
//    42  90
function SK42_to_PZ90_height(latSK42, longSK42, HeightSK42: float): float; cdecl;
//    90  42
function PZ90_to_SK42_latitude(latPZ90, longPZ90, HeightPZ90: float): float; cdecl;
//    90  42
function PZ90_to_SK42_longitude(latPZ90, longPZ90, HeightPZ90: float): float; cdecl;
//    90  42
function PZ90_to_SK42_height(latPZ90, longPZ90, HeightPZ90: float): float; cdecl;
//    42  WGS84
function SK42_to_WGS84_latitude(latSK42, longSK42, HeightSK42: float): float; cdecl;
//    42  WGS84
function SK42_to_WGS84_longitude(latSK42, longSK42, HeightSK42: float): float; cdecl;
//    42  WGS84
function SK42_to_WGS84_height(latSK42, longSK42, HeightSK42: float): float; cdecl;
//    WGS84  42
function WGS84_to_SK42_latitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl;
//    WGS84  42
function WGS84_to_SK42_longitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl;
//    WGS84  42
function WGS84_to_SK42_height(latWGS84, longWGS84, HeightWGS84: float): float; cdecl;
function SK95_to_PZ90_latitude(latSK95, longSK95, HeightSK95: float): float; cdecl;
function SK95_to_PZ90_longitude(latSK95, longSK95, HeightSK95: float): float; cdecl;
function SK95_to_PZ90_height(latSK95, longSK95, HeightSK95: float): float; cdecl;
function SK95_to_WGS84_latitude(latSK95, longSK95, HeightSK95: float): float; cdecl;
function SK95_to_WGS84_longitude(latSK95, longSK95, HeightSK95: float): float; cdecl;
function SK95_to_WGS84_height(latSK95, longSK95, HeightSK95: float): float; cdecl;
function SK42_to_SK95_latitude(latSK42, longSK42, HeightSK42: float): float; cdecl;
function SK42_to_SK95_longitude(latSK42, longSK42, HeightSK42: float): float; cdecl;
function SK42_to_SK95_height(latSK42, longSK42, HeightSK42: float): float; cdecl;
function ITRF93_to_WGS84_latitude(latITRF93, longITRF93, HeightITRF93: float): float; cdecl;
function ITRF93_to_WGS84_longitude(latITRF93, longITRF93, HeightITRF93: float): float; cdecl;
function ITRF93_to_WGS84_height(latITRF93, longITRF93, HeightITRF93: float): float; cdecl;
function WGS84_to_ITRF93_latitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl;
function WGS84_to_ITRF93_longitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl;
function WGS84_to_ITRF93_height(latWGS84, longWGS84, HeightWGS84: float): float; cdecl;
//        
function spatial_value_x(Latitude, Longidute, Height, N: float): float; cdecl;
function spatial_value_y(Latitude, Longidute, Height, N: float): float; cdecl;
function spatial_value_z(Latitude, Height, N, E2: float): float; cdecl;
function spatial_value_x_sk42(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_y_sk42(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_z_sk42(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_x_pz90(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_y_pz90(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_z_pz90(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_x_wgs84(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_y_wgs84(Latitude, Longidute, Height: float): float; cdecl;
function spatial_value_z_wgs84(Latitude, Longidute, Height: float): float; cdecl;
procedure geodesy_from_spatial(x, y, z, e2, a: float; var B, L, H: float); cdecl;
function geodesy_from_spatial_latitude_sk42(x, y, z: float): float; cdecl;
function geodesy_from_spatial_longitude_sk42(x, y, z: float): float; cdecl;
function geodesy_from_spatial_height_sk42(x, y, z: float): float; cdecl;
function geodesy_from_spatial_latitude_wgs84(x, y, z: float): float; cdecl;
function geodesy_from_spatial_longitude_wgs84(x, y, z: float): float; cdecl;
function geodesy_from_spatial_height_wgs84(x, y, z: float): float; cdecl;
function geodesy_from_spatial_latitude_pz90(x, y, z: float): float; cdecl;
function geodesy_from_spatial_longitude_pz90(x, y, z: float): float; cdecl;
function geodesy_from_spatial_height_pz90(x, y, z: float): float; cdecl;
function Ellipse_XXX(EllipseID: Byte): float; cdecl;
function alpha_XXX(EllipseID: byte): float; cdecl;
function e2_xxx(EllipseID: byte): float; cdecl;
function N_xxx(EllipseID: byte; latitude: float): float; cdecl;



function calc_vincent_distance(lat1, long1, lat2, long2: float; Ellipse: byte): float; cdecl;
function calc_vincent_inial_bearing(lat1, long1, lat2, long2: float; Ellipse: byte): float; cdecl;
function calc_vincent_reverse_latitude(lat1, long1, azimuth, distance: float; ellipse: byte): float; cdecl;
function calc_vincent_reverse_longitude(lat1, long1, azimuth, distance: float; ellipse: byte): float; cdecl;
function calc_vincent_reverse_bearing(lat1, long1, lat2, long2: float; Ellipse: byte): float; cdecl;
function calc_vincent_reverse_azimuth(lat1, long1, azimuth, distance: float; ellipse: byte): float; cdecl;

procedure FloatToDegMinSec(X: Float; var Degs, Mins, Secs: Float); cdecl;
function RemainderFloat(X, Y: Float): Float; cdecl;

implementation

function ellipse_PZ90: float; cdecl; external LibName;
function alpha_PZ90: float; cdecl; external LibName;
function e2_PZ90: float; cdecl; external LibName;
function N_PZ90(latitude: float): float; cdecl; external LibName;
function ellipse_WGS84: float; cdecl; external LibName;
function alpha_WGS84: float; cdecl; external LibName;
function e2_WGS84: float; cdecl; external LibName;
function N_WGS84(latitude: float): float; cdecl; external LibName;
function ellipse_SK42: float; cdecl; external LibName;
function alpha_SK42: float; cdecl; external LibName;
function e2_SK42: float; cdecl; external LibName;
function N_SK42(latitude: float): float; cdecl; external LibName;
function ellipse_SK95: float; cdecl; external LibName;
function alpha_SK95: float; cdecl; external LibName;
function e2_SK95: float; cdecl; external LibName;
function N_SK95(latitude: float): float; cdecl; external LibName;

function geo_distance_sk42(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl; external LibName;
function geo_distance_PZ90(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl; external LibName;
function geo_distance_WGS84(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl; external LibName;
function geo_distance_SK95(Latitude1, Longitude1, Latitude2, Longitude2: float): float; cdecl; external LibName;
function gauss_kruger_zone(L :float): Integer; cdecl; external LibName;
function gauss_kruger_distance0(L: float): float; cdecl; external LibName;
function gauss_kruger_x(latitude, longitude: float): float; cdecl; external LibName;
function gauss_kruger_y(latitude, longitude: float): float; cdecl; external LibName;
function gauss_kruger_latitude(x, y: float): float; cdecl; external LibName;
function gauss_kruger_longitude(x, y: float): float; cdecl; external LibName;
procedure transform_coo(ellipseFrom, ellipseTo: float; e2From, e2To: float;
  alphaFrom, alphaTo: float; latFrom, LongFrom, HeightFrom: float; dX, dY, dZ, wX, wY, wZ, dM: float;
  var latTo, longTo, HeightTo: float); cdecl; external LibName;
function SK42_to_PZ90_latitude(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function SK42_to_PZ90_longitude(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function SK42_to_PZ90_height(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function PZ90_to_SK42_latitude(latPZ90, longPZ90, HeightPZ90: float): float; cdecl; external LibName;
function PZ90_to_SK42_longitude(latPZ90, longPZ90, HeightPZ90: float): float; cdecl; external LibName;
function PZ90_to_SK42_height(latPZ90, longPZ90, HeightPZ90: float): float; cdecl; external LibName;
function SK42_to_WGS84_latitude(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function SK42_to_WGS84_longitude(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function SK42_to_WGS84_height(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function WGS84_to_SK42_latitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl; external LibName;
function WGS84_to_SK42_longitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl; external LibName;
function WGS84_to_SK42_height(latWGS84, longWGS84, HeightWGS84: float): float; cdecl; external LibName;
function SK95_to_PZ90_latitude(latSK95, longSK95, HeightSK95: float): float; cdecl; external LibName;
function SK95_to_PZ90_longitude(latSK95, longSK95, HeightSK95: float): float; cdecl; external LibName;
function SK95_to_PZ90_height(latSK95, longSK95, HeightSK95: float): float; cdecl; external LibName;
function SK95_to_WGS84_latitude(latSK95, longSK95, HeightSK95: float): float; cdecl; external LibName;
function SK95_to_WGS84_longitude(latSK95, longSK95, HeightSK95: float): float; cdecl; external LibName;
function SK95_to_WGS84_height(latSK95, longSK95, HeightSK95: float): float; cdecl; external LibName;
function SK42_to_SK95_latitude(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function SK42_to_SK95_longitude(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function SK42_to_SK95_height(latSK42, longSK42, HeightSK42: float): float; cdecl; external LibName;
function spatial_value_x(Latitude, Longidute, Height, N: float): float; cdecl; external LibName;
function spatial_value_y(Latitude, Longidute, Height, N: float): float; cdecl; external LibName;
function spatial_value_z(Latitude, Height, N, E2: float): float; cdecl; external LibName;
function spatial_value_x_sk42(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_y_sk42(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_z_sk42(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_x_pz90(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_y_pz90(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_z_pz90(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_x_wgs84(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_y_wgs84(Latitude, Longidute, Height: float): float; cdecl; external LibName;
function spatial_value_z_wgs84(Latitude, Longidute, Height: float): float; cdecl; external LibName;
procedure geodesy_from_spatial(x, y, z, e2, a: float; var B, L, H: float); cdecl; external LibName;
function geodesy_from_spatial_latitude_sk42(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_longitude_sk42(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_height_sk42(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_latitude_wgs84(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_longitude_wgs84(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_height_wgs84(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_latitude_pz90(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_longitude_pz90(x, y, z: float): float; cdecl; external LibName;
function geodesy_from_spatial_height_pz90(x, y, z: float): float; cdecl; external LibName;
function calc_distance_gaversinus(latitude1, longitude1, latitude2, longitude2, A : float): float; cdecl; external LibName;
function calc_distance_gaversinus_large(latitude1, longitude1, latitude2, longitude2, A : float): float; cdecl; external LibName;
function calc_initial_bearing(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_SK42(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_large_SK42(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_PZ90(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_large_PZ90(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_WGS84(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_large_WGS84(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_SK95(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;
function calc_distance_gaversinus_large_SK95(latitude1, longitude1, latitude2, longitude2: float): float; cdecl; external LibName;

function ITRF93_to_WGS84_latitude(latITRF93, longITRF93, HeightITRF93: float): float; cdecl;  external LibName;
function ITRF93_to_WGS84_longitude(latITRF93, longITRF93, HeightITRF93: float): float; cdecl; external LibName;
function ITRF93_to_WGS84_height(latITRF93, longITRF93, HeightITRF93: float): float; cdecl; external LibName;
function WGS84_to_ITRF93_latitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl; external LibName;
function WGS84_to_ITRF93_longitude(latWGS84, longWGS84, HeightWGS84: float): float; cdecl; external LibName;
function WGS84_to_ITRF93_height(latWGS84, longWGS84, HeightWGS84: float): float; cdecl; external LibName;
function Ellipse_XXX(EllipseID: Byte): float; cdecl; external LibName;
function alpha_XXX(EllipseID: byte): float; cdecl; external LibName;
function e2_xxx(EllipseID: byte): float; cdecl; external LibName;
function N_xxx(EllipseID: byte; latitude: float): float; cdecl; external LibName;
function calc_vincent_distance(lat1, long1, lat2, long2: float; Ellipse: byte): float; cdecl; external LibName;
function calc_vincent_inial_bearing(lat1, long1, lat2, long2: float; Ellipse: byte): float; cdecl; external LibName;
function calc_vincent_reverse_latitude(lat1, long1, azimuth, distance: float; ellipse: byte): float; cdecl; external LibName;
function calc_vincent_reverse_longitude(lat1, long1, azimuth, distance: float; ellipse: byte): float; cdecl; external LibName;
function calc_vincent_reverse_bearing(lat1, long1, lat2, long2: float; Ellipse: byte): float; cdecl; external LibName;
function calc_vincent_reverse_azimuth(lat1, long1, azimuth, distance: float; ellipse: byte): float; cdecl; external LibName;

procedure FloatToDegMinSec(X: Float; var Degs, Mins, Secs: Float); cdecl; external LibName;
function RemainderFloat(X, Y: Float): Float; cdecl; external LibName;

end.
